/* --------------------------------------------------------------------------
 * BreakOut
 * --------------------------------------------------------------------------
 * prog:  Martin Dusek (template by Max Rheiner)
 * date:  25/09/2013 (m/d/y)
 * ----------------------------------------------------------------------------
 */

import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;
AudioPlayer soundtrack;

BouncingBall ball;
Racket       schlaeger = null;
Brick[]      brickList = null;

final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;
final static int GAME_MODE_WIN       = 3;

int          gameMode = GAME_MODE_MENU;
int  tote_bricks = 0; // Anzahl verschwundene Bricks

PShape background;
PShape text_menu2;
PShape game_over;
PShape win;
PFont font;
PFont normalfont;

void setup()
{ 
  size(800, 600); 

  ball = new BouncingBall(width/2, height/2, 7);
  
  fill(200,200,255);
  schlaeger = new Racket(0, height - 40, 170, 15);   

  // sound init
  minim = new Minim(this);
  ballHitSnd = minim.loadSample("rock_sound3.mp3");
  ballHitSchlaegerSnd = minim.loadSample("glass_sound.mp3");
  soundtrack = minim.loadFile("cave_sound.mp3");
  
  background  = loadShape("background.svg");
  text_menu2 = loadShape("text_menu2.svg");
  game_over = loadShape("game_over.svg");
  win = loadShape("win.svg");  
  shapeMode(CENTER);    // nullpunkt des svg-objekts liegt in der mitte
  
  smooth(); 
  noCursor();
}

void initGameScene()
{
  // setzte die start posititon des balles
  ball.set(new PVector(width/2, height/2), new PVector(random(-7, 7), -7), 1);

  soundtrack.play();
  soundtrack.loop();
  // erzeuge die ziegel
  brickList = new Brick[32];
  for (int i=0;i < brickList.length;i++)
  {
    if (i<=7)
    brickList[i] = new Brick(200 + i * 55, 100, 50, 50);
    else if (i>=7 && i <=15)
    brickList[i] = new Brick(200 + (i-8) * 55, 160, 50, 50);
    else if (i>=15 && i <=23)
    brickList[i] = new Brick(200 + (i-16) * 55, 220, 50, 50);
    else if (i>=22 && i <=32)
    brickList[i] = new Brick(200 + (i-24) * 55, 280, 50, 50);
    
    
  }
}


void draw()
{
  // ghosting
  stroke(255);
  strokeWeight(5);
  fill(0, 0, 0, 100);
  rect(0, 0, width, height);
  noStroke();
  drawScene();
}

void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;  
  case GAME_MODE_WIN:
    drawWin();
    break;
    
  }
}

void drawMenu()
{ 
  /* Grösser/Kleiner werden des Menu Texts
  int zaehler = 0;
  if(zaehler == 20){
    zaehler = 0;
  }
  else{
    zaehler++;
  }
  shape(background,width/2,height/2,width*1.1,height*1.1);
  shape(text_menu2,width/2,height/2,(zaehler+width)*1.1,(zaehler+height)*1.1);
  */
  
  shape(background,width/2,height/2,width*1.1,height*1.1);
  shape(text_menu2,width/2,height/2,width*1.1,height*1.1);
  
  /*fill(0,0,0,100);
  rect(0,0,width,height);
  pushStyle();
  fill(255);
  font = loadFont("Verdana-BoldItalic-30.vlw");
  textFont(font);
  textSize(30);
  fill(180,180,225,200);
  text("Destroy the rocks to find a way out !", (width/2)-300, (height/2)-80);
  strokeWeight(5);
  stroke(220,220,255,200);
  line((width/2)-300, (height/2)-70,(width/2)+312, (height/2)-70);
  fill(220,220,255);
  textSize(15);  
  text("press 'p' to play", (width/2)-70, (height/2)-20);
  fill(215,210,255);
  text("press 'Space' to ruturn here", (width/2)-130, (height/2)+10);  
  popStyle();
  */
}

void drawGameOver()
{ 
  shape(game_over,width/2,height/2,width*1.1,height*1.1);
  /*
  fill(255,225,220);
  textSize(30);
  normalfont = loadFont("Verdana-30.vlw");
  textFont(normalfont);
  text("G a m e   O v e r", (width/2)-150, height/2);
  fill(255,225,255);
  textSize(15);
  text("You will be for ever in this cave ...", (width/2)-150, height/2+35);
  text("Or press 'p' and try again !", (width/2)-150, height/2+55);
  */
}

void drawWin()
{
  background(0);
  shape(win,width/2,height/2,width,height);
}

void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();

  // zeichne ziegel
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
      brickList[i].draw();
  }

  // zeichne den ball
  ball.draw();

  // zeichne schlaeger
  schlaeger.draw();
}

void keyPressed()
{
  switch(key)
  {
  case 'p':
    // start game
    gameMode = GAME_MODE_PLAY;
    initGameScene();
    break;
  case ' ':
    // end
    gameMode = GAME_MODE_MENU;
    break;
  }
}

void  updateScene()
{
  // test ob ball aus dem spielfeld ist
  if (ball._pos.y > height- ball._r)
  {
    gameMode = GAME_MODE_GAMEOVER;
    return;
  }

  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);
  
  PVector hitPos = new PVector();
  float  hitV;
  float  speed;
  
  // teste ob ball den schlaeger trifft
  int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
  switch(retVal)
  {
  case Brick.HIT_LEFT:
     // aendere flugrichtung ball
    ball._dir.x *= -1;
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)    (nur damits schön ist, und logisch)
    ball._pos.x = schlaeger._pos.x - schlaeger._w/2 - ball._r;
    
    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_RIGTH:
     // aendere flugrichtung ball
    ball._dir.x *= -1;
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x + schlaeger._w/2 + ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_TOP:
     // aendere flugrichtung ball
    
    // anschnitt berechnen (wie beim PingPong)
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y - schlaeger._h/2 - ball._r ;
    
    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break; 
  case Brick.HIT_BOTTOM:
    // aendere flugrichtung ball
    
    // anschnitt berechnen 
     hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;
    
    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;
    
    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);
   
    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y + schlaeger._h/2 + ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  }
  
  // test ob ball einen ziegel trifft
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
    {
      retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
      switch(retVal)
      {
      case Brick.HIT_LEFT:
      case Brick.HIT_RIGTH:
        // aendere flugrichtung ball
        ball._dir.x *= -1;

        // entferne ziegel aus liste
        if (brickList[i]._life > 0) {
          brickList[i]._life -= 1;
          
        } else {
          brickList[i] = null;
          tote_bricks ++;

        }
        
        // spiele sound
        ballHitSnd.trigger();
        break;
      case Brick.HIT_TOP:
      case Brick.HIT_BOTTOM:
        // aendere flugrichtung ball
        ball._dir.y *= -1;

        // entferne ziegel aus liste
        if (brickList[i]._life > 0) {
          brickList[i]._life -= 1;
        } else {
          brickList[i] = null;
          tote_bricks ++;

        }

        // spiele sound
        ballHitSnd.trigger();
        break;
      }
    }
  }
  // test ob man gewonnen hat
  if(tote_bricks == 32)
  {
    gameMode = GAME_MODE_WIN;
    return;
  }  
  
}





